import mysql.connector
import model
import message_util

DB_HOST = '000.000.000.000'
DB_USER = 'userBD'
DB_PASS = 'passBD'
DB_NAME = 'nameBD'

def run_query(query=''): 
	"""
	Method to launch any type of SQL query in the query DB: SQL instruction to execute
	"""
	datos = [DB_HOST, DB_USER, DB_PASS, DB_NAME]  
	conn = mysql.connector.connect(host=DB_HOST,
                                         database=DB_NAME,
                                         user=DB_USER,
                                         password=DB_PASS) # Conectar a la base de datos
	try:		 
		cursor = conn.cursor()         # Crear un cursor
		cursor.execute(query)          # Ejecutar una consulta
		if query.upper().startswith('SELECT'): 
			data = cursor.fetchall()   # Traer los resultados de un select
		else: 
			conn.commit()              # Hacer efectiva la escritura de datos
			data = None  
		cursor.close()                # Cerrar el cursor
		  
		return data
	except Exception as ex1:
		return "ERROR EN QUERY " + type(ex1).__name__ + str(ex1)
	finally:
		conn.close()                   # Cerrar la conexion


# Check that the DEVICE is in the DB [authorization, device, Pins]
def autorize_device(MQTTID):
    query="""SELECT * FROM iot_django_device where device_is_active = 1 and device_MQTT_ID ='{}'""".format(MQTTID)
    #print(query)
    returnList=[]
    resultado=run_query(query)
    #print(len(resultado))
    if(len(resultado)<1):
        returnList.append(False)
        returnList.append(resultado)
        return returnList
    returnList.append(True)
    returnList.append(resultado[0])
    query="""SELECT *FROM iot_django_action where device_device_id ='{}' """.format(resultado[0][0])    
    resultado2=run_query(query)    
    returnList.append(resultado2)
    return returnList


def getAplicationQuery(action_id):
    try:
        if(action_id is None):
            return
        query="""SELECT * FROM iot_django_application where id ='{}'""".format(action_id)
        resultado=run_query(query)
        return resultado[0]
    except:
        return []

"""
Go through the actions and pins of the equipment and check that those that are passed by parameter
They are authorized in that team
EJ--> id_device/readtemp/6 --->True
If this action is True, it indicates that the device with ID id_device can "readtemp" in GPIO 6
"""
def autorize_action_and_pin(device, action, gpio):
    for act in device.device_actions:       
        if(action==act.pin_type and int(gpio)==int(act.pin_number)):
            return True#tiene que estar la accion dada de alta y el pin
    return False

def get_actions_id(id):
    try:
        query="""SELECT * FROM iot_django_action where device_device_id ='{}' """.format(id)
        
        resultado=run_query(query)
        return resultado
    except Exception as ex:
        print("ERROR recuperando device " + type(ex).__name__ + " " + ex.line)
        return[]


def get_device_mqttid(id):
    try:
        query="""SELECT * FROM iot_django_device where device_is_active = 1 and device_MQTT_ID ='{}'""".format(id)
        resultado=run_query(query)
        resultado2=[]
        if(len(resultado)>0):
            resultado2=get_actions_id(resultado[0][0])          
        #print(device)
        return [resultado,resultado2]
    except Exception as ex:
        print("ERROR recuperando device " + type(ex).__name__ + " " + str(ex))
        return[]

def get_aclion_last_value(id_device, id_action, gpio):    
    try:
        query2="""SELECT action_values_values FROM iot_django_action_values where action_values_device_id = '{}' AND  action_values_action_id = '{}' AND  action_values_discriminate = '{}' ORDER BY action_values_created_at DESC LIMIT 1""".format(str(id_device), str(id_action), str(gpio))
        resultado=run_query(query2)
        if(len(resultado)>0):
            return resultado[0][0]
        else:
            return []
    except Exception as ex:
        print("ERROR recuperando device " + type(ex).__name__ + " " + str(ex))
        return[]

def get_aclion_last_value_all(id_device, id_action, gpio):    
    try:
        query2="""SELECT * FROM iot_django_action_values where action_values_device_id = '{}' AND  action_values_action_id = '{}' AND  action_values_discriminate = '{}' ORDER BY action_values_created_at DESC LIMIT 1""".format(str(id_device), str(id_action), str(gpio))
        resultado=run_query(query2)
        if(len(resultado)>0):
            return resultado[0]
        else:
            return []        
    except Exception as ex:
        print("ERROR recuperando device " + type(ex).__name__ + " " + str(ex))
        return[]


def insert_action_value(device, value, action_id,discriminate):
    try:
        #print (value)
        query="""
        INSERT INTO iot_django_action_values 
        (action_values_device_id, action_values_values, action_values_action_id,action_values_created_at,action_values_discriminate) 
        VALUES ('{}', '{}','{}', now(),'{}');""".format(device, str(value), action_id,discriminate)        
        resultado = run_query(query)
        return [resultado]
    except Exception as ex:
        print("ERROR recuperando device " + type(ex).__name__ + " " + str(ex))
        return[]

"""
Method that returns the average of temperature values of the last calendar hour
"""
def get_temperature_avg(id_device, id_action, gpio):
    try:
        query_avg_temperature ="""SELECT round(AVG(action_values_values),2) AS action_values_values
                                FROM iot_django_action_values
                                where action_values_device_id = '{}' AND  action_values_action_id = '{}' 
                                AND  action_values_discriminate = '{}' and
                                date(now() ) = date(action_values_created_at) and
                                hour(now() ) = hour(action_values_created_at);""".format(str(id_device), str(id_action), str(gpio))
        resultado=run_query(query_avg_temperature)
        return float(resultado[0][0])
    except:
        return "ERROR"


"""
Method that returns the average of temperature values of the last calendar hour
"""
def get_temperature_dht22_avg(id_device, id_action, gpio):
    try:
        query_avg_temperature ="""SELECT round(AVG(action_values_values),2) AS action_values_values
                                FROM iot_django_action_values
                                where action_values_device_id = '{}' AND  action_values_action_id = '{}' 
                                AND  action_values_discriminate = '{}' and
                                date(now() ) = date(action_values_created_at) and
                                hour(now() ) = hour(action_values_created_at);""".format(str(id_device), str(id_action), str(gpio)+"_temp")
        resultado=run_query(query_avg_temperature)
        return float(resultado[0][0])
    except:
        return "ERROR"


"""
Method that returns the average of humidity values of the last calendar hour
"""
def get_humidity_dht22_avg(id_device, id_action, gpio):
    try:
        query_avg_temperature ="""SELECT round(AVG(action_values_values),2) AS action_values_values
                                FROM iot_django_action_values
                                where action_values_device_id = '{}' AND  action_values_action_id = '{}' 
                                AND  action_values_discriminate = '{}' and
                                date(now() ) = date(action_values_created_at) and
                                hour(now() ) = hour(action_values_created_at);""".format(str(id_device), str(id_action), str(gpio)+"_hum")
        resultado=run_query(query_avg_temperature)
        return float(resultado[0][0])
    except:
        return "ERROR"

"""
Method that processes 2 values, one from the database (average of values from the last calendar hour)
and another obtained from the sensors (average of all temperature sensors), and returns an average
or an error according to the data.
"""
def get_avg_float_values(value_sensor,value_database):
    return_temperature_value=0.0
    #Obtain processed value of the sensor that they send us
    value_sensor_process=message_util.process_temperature(value_sensor)
    #obtain the processed value of the database that they send us (average of the hour)
    value_database_process=message_util.process_temperature(value_database)
    #if both are errors, we return error so that nothing is stored
    if(value_database_process=="ERROR" and value_sensor_process=="ERROR"):
        return "ERROR"
    #if the one from the database is error, but the value obtained is valid, we pass the value obtained
    elif(value_database_process=="ERROR" and value_sensor_process!="ERROR"):
        return round(value_sensor_process,2)
    #if both are valid (they are neither error), we do the average
    elif(value_database_process!="ERROR" and value_sensor_process!="ERROR"):
        return round((value_database_process+value_sensor_process)/2,2)
    #in any other case we return error
    else:
        return "ERROR"


def delete_hour_value(id_device, id_action, gpio):
    query_avg_temperature_delete ="""DELETE 
                            FROM iot_django_action_values
                            where action_values_device_id = '{}' AND  action_values_action_id = '{}' 
                            AND  action_values_discriminate = '{}' and
                            date(now() ) = date(action_values_created_at) and
                            hour(now() ) = hour(action_values_created_at);""".format(str(id_device), str(id_action), str(gpio))
    #query_id="ALTER TABLE `iot_django_action_values` AUTO_INCREMENT = (SELECT MAX( `id` ) FROM `iot_django_action_values`);"
    run_query(query_avg_temperature_delete)
    #run_query(query_id);


def insert_act_gpio(device):
    try:
        query = """
        INSERT INTO iot_django_action_values
	    (action_values_device_id, action_values_values, action_values_created_at, action_values_action_id)
	    VALUES ({}, '', '', NOW(), 0)""".format()

        salida = run_query(query)
        return salida
    except Exception as ex:
        return "ERROR INSERTANDO " + type(ex).__name__ + " " + ex.line


def check_alarm_cpd(device):
    for action in device.device_actions:
        if(action.aplication is not None):
            if(action.aplication.name == "cpds_monitor"):
                pass
            #future development