import db_util


class Device:
    def __init__(self, id_mqtt):
        self.BBDD_complet=db_util.get_device_mqttid(id_mqtt)
        self.BBDD=self.BBDD_complet[0]
        self.id = self.BBDD[0][0]
        self.device_name=self.BBDD[0][1]
        self.device_alias=self.BBDD[0][2]
        self.device_location_latitude=self.BBDD[0][3]
        self.device_location_longitude=self.BBDD[0][4]
        self.device_MQTT_ID=self.BBDD[0][5]
        self.device_user=self.BBDD[0][6]
        self.device_description=self.BBDD[0][7]
        self.device_is_active=self.BBDD[0][8]
        self.device_created_at=self.BBDD[0][9]
        self.device_updated_at=self.BBDD[0][10]
        self.device_actions=[]
        if(len(self.BBDD_complet[1])>0):
            for act in self.BBDD_complet[1]:
                self.device_actions.append(Action(act))

class Application:
    def __init__(self, BBDD):
        self.id =  BBDD[0]
        self.name =  BBDD[1]
        self.description =  BBDD[2]
        self.created_at = BBDD[3]
        self.updated_at = BBDD[4]


class Action:
    def __init__(self, BBDD):    
        self.id=BBDD[0]
        self.pin_name=BBDD[1]
        self.pin_description =BBDD[2]
        self.pin_created_at =BBDD[3]
        self.pin_updated_at =BBDD[4]
        self.pin_number= BBDD[5]               
        self.pin_type =BBDD[8]
        self.aplication_id =BBDD[9]
        self.aplication_query= db_util.getAplicationQuery(self.aplication_id)
        self.aplication = None
        try:
            self.aplication = Application(self.aplication_query)
        except:
            pass

class MessageData:
    def __init__(self, msg, client):
        self.client=client
        self.mensaje_string = msg.payload.decode("utf-8")
        self.separador = msg.topic.split("/")
        self.id_device = ""
        self.c=""
        self.action = ""
        self.app = ""
        self.gpio = ""
        self.initClass()

    def initClass(self):
        try:     
            if(len(self.separador)>2):            
                if("_" in str(self.separador[0])):
                    self.id_device = self.separador[0].split("_")[0]                
                    self.id_instalce= self.separador[0].split("_")[1]
                else:
                    self.id_device = self.separador[0]
                try:
                    self.action = self.separador[1]
                    self.gpio = self.separador[2]
                except:
                    #mensaje de status
                    pass
        except Exception as ex:
           print("MODEL/MessageData"+str(ex))

    def testCorrectData(self):
        if(len(self.separador)<=2):
            return False;
        elif(len(self.id_device)<1):
            return False;
        elif(len(self.action)<1):
            return False;
        elif(len(self.gpio)<1):
            return False;
        else:
            return True
        
    		
