
import sys
import paho.mqtt.client as mqtt 
import time , threading
import gpioUtil as util
import random
import string
import configparser
import json
from datetime import datetime
import system_read_config as configuration

from paho.mqtt import client as mqtt_client



#MQTT CONFIG
mqtt_server = configuration.mqtt_server
mqtt_port = configuration.mqtt_port
device_id = configuration.device_id+"_input_instalnce"

#INPUT CONFIG
read_input = configuration.read_input
input_gpio = configuration.input_gpio

GLOBAL_GPIO_STATUS={}

def on_disconnect(client, userdata, rc):
    tryToConnect=True
    try:
        client.connected_flag=False #set flag
        while tryToConnect:
            time.sleep(10)
            util.printLog("Desconectado!, Intentando conexion con el Broker RAZÓN-->"+str(rc))
            client.connect(mqtt_server, mqtt_port, keepalive=30)
            tryToConnect=False
            
    except:
        util.printLog("Conexion Fallida")

def on_connect(client, userdata, flags, rc):
    if rc==0:
        client.connected_flag=True #set flag
        util.printLog("Conexión Establecida con éxito")
        init_global_status(client,True)
    else:
        util.printLog("Conexión erronea a Broker, codigo de error=",rc)
        client.connected_flag=False #set flag

def init_global_status(client, force):
    if(len(GLOBAL_GPIO_STATUS)==0 or force):
        for gpio in input_gpio:
            state=util.leerGPIO(int(gpio))
            status=publish(device_id.split("_")[0]+"/readinput/"+str(gpio), str(state))
            util.printLog("Publicando-->"+str(gpio)+" ESTADO--> "+str(state))
            GLOBAL_GPIO_STATUS[gpio]=state
        util.printLog("estado al iniciar : "+str(GLOBAL_GPIO_STATUS))

# send  measurement
def send_measurements(client):
    try:     
        if(read_input==1):
            init_global_status(client, False)
            for gpio in input_gpio:                
                state=util.leerGPIO(int(gpio))
                status=0  
                if(state != GLOBAL_GPIO_STATUS[gpio]):
                    #the entries are different, you have to publish the change
                    status=publish(device_id.split("_")[0]+"/readinput/"+str(gpio), str(state))
                    util.printLog("Publicando-->"+str(gpio)+" ESTADO--> "+str(state))
                    GLOBAL_GPIO_STATUS[gpio]=state
                else:
                    pass
                if(status!=0):
                    util.printLog("Error de conexión al publicar, "+str(status))
                    try:
                        util.printLog("Intentando reconexion ...")
                        client.connect(mqtt_server, mqtt_port, keepalive=60)
                    except:
                        util.printLog("Conexion Fallida")
        time.sleep(1)                  
    except (KeyboardInterrupt, SystemExit):
        util.printLog("Interrupcion de teclado ... ") 




# publish a message
def publish(topic, message):
    mid = client.publish(topic, message, qos=0, retain=False)
    status = mid[0]
    return status



client = mqtt.Client(client_id=(device_id+"_"), clean_session=True, userdata=None, transport="tcp")
client.on_connect=on_connect
client.on_disconnect = on_disconnect



# create connection, the three parameters are broker address, port number, and hold time
tryToConnect=True
while tryToConnect:
    try:
        util.printLog("Intentando conexion con el Broker")
        time.sleep(10)
        client.connect(mqtt_server, mqtt_port, keepalive=30)
        tryToConnect=False        
    except:
        util.printLog("Conexion Fallida")

while True:
    send_measurements(client)    
    client.loop_start()