
import sys
import paho.mqtt.client as mqtt 
import time , threading
import gpioUtil as util
import random
import string
import configparser
import json
from datetime import datetime
import system_read_config as configuration

#MQTT CONFIG
mqtt_server = configuration.mqtt_server
mqtt_port = configuration.mqtt_port
device_id = configuration.device_id+"_temperature_instance"


#SENSOR CONFIG
read_temperature = configuration.read_temperature
time_publish = configuration.time_publish_temp
gpio_pin = configuration.gpio_tem_pin

# send  measurement
def send_measurements(client):
    try:
        if(read_temperature=="1"):
            temps=util.get_temperature_media()
            print(device_id.split("_")[0]+"/readtemp/"+gpio_pin)
            status=publish(device_id.split("_")[0]+"/readtemp/"+gpio_pin, str(temps))
            
            if(status!=0):
                print("Connection Error "+str(status))
                try:
                    print("Try to reconnect ...")
                    client.connect(mqtt_server, mqtt_port, keepalive=60)
                except:
                    print("connection failed")
            print("Send temp" + str(datetime.now().strftime("%d/%m/%Y %H:%M:%S"))+" T--> "+str(temps))
        else:
            time.sleep(int(time_publish))
            return 
        time.sleep(int(time_publish))
    except (KeyboardInterrupt, SystemExit):
        print("Received keyboard interrupt, quitting ...")
        
# publish a message
def publish(topic, message):
    mid = client.publish(topic, message, qos=0, retain=False)
    status = mid[0]
    return status



client = mqtt.Client(client_id=(device_id+"_"), clean_session=True, userdata=None, transport="tcp")

# create connection, the three parameters are broker address, port number, and hold time
tryToConnect=True
while tryToConnect:
    try:
        print("Try to connect")
        time.sleep(10)
        client.connect(mqtt_server, mqtt_port, keepalive=30)
        tryToConnect=False        
    except:
        print("connection failed")

#sensor read

while True:
    send_measurements(client)    
    print(threading.current_thread().ident)
    client.loop_start()