from django.db import models
from django.contrib.auth.models import User
from iot_django.models.device import *
# import paho.mqtt.publish as publish
# from django.dispatch import receiver
# from django.db.models.signals import post_save


class Cpd(models.Model):
    name = models.CharField(max_length=100,verbose_name="Nombre del dispositivo")
    alias = models.CharField(max_length=200,verbose_name="Alias del dispositivo")
    device = models.ForeignKey(Device, null=True,blank=True, on_delete=models.SET_NULL,verbose_name="Dispositivo")
    user = models.ForeignKey(User, null=True,blank=True, on_delete=models.SET_NULL,verbose_name="Usuario")
    description = models.CharField(max_length=500,verbose_name="Descripcion")
    is_active = models.IntegerField(default=0,verbose_name="Dispositivo activo") #0-->Not active, 1 --> active    
    created_at =models.DateTimeField(auto_now_add=True,verbose_name="Creación")
    updated_at =models.DateTimeField(auto_now=True,verbose_name="Actualización")
    max_temperature_alarm = models.IntegerField(default=26,verbose_name="Temperatura Alarma superior")    
    max_humidity_alarm = models.IntegerField(default=90,verbose_name="Humedad Alarma superior") 
    aplication = models.ForeignKey(Application, null=True,blank=True, on_delete=models.SET_NULL,verbose_name="Aplicacion")
    class Meta:
        verbose_name="cpd"
        verbose_name_plural="cpds"
        ordering= ["-updated_at"]
        permissions = (("access_cpds_aplications", "El usuario puede acceder a esta aplicacion"),)
    def __str__(self):
        return self.alias

# class Alarm_Type(models.Model):
#     name = models.CharField(max_length=100,verbose_name="Nombre del tipo de alarma")
#     alias = models.CharField(max_length=200,verbose_name="Alias del alarma")
#     description = models.CharField(max_length=500,verbose_name="Descripcion")
#     user = models.ForeignKey(User, null=True,blank=True, on_delete=models.SET_NULL,verbose_name="Usuario")
#     def __str__(self):
#         return self.alias
#     class Meta:
#         verbose_name="Tipo de alarma"
#         verbose_name_plural="Tipos de alarma"



# class Alarm(models.Model):
#     name = models.CharField(max_length=100,verbose_name="Nombre de alarma")
#     description = models.CharField(max_length=500,verbose_name="Descripcion")
#     actual_state = models.CharField(max_length=50,default="OFF",verbose_name="Estado actual")
#     user = models.ForeignKey(User, null=True,blank=True, on_delete=models.SET_NULL,verbose_name="Usuario")
#     type = models.ForeignKey(Alarm_Type, null=True,blank=True, on_delete=models.SET_NULL,verbose_name="Tipo de alarma")
#     emails = models.CharField(max_length=200,verbose_name="Emails envio alarma (separados ';' )")
#     max_temperature_alarm = models.IntegerField(default=26,verbose_name="Temperatura Alarma superior")    
#     max_humidity_alarm = models.IntegerField(default=90,verbose_name="Humedad Alarma superior") 
#     min_temperature_alarm = models.IntegerField(default=0,verbose_name="Temperatura Alarma inferior")    
#     min_humidity_alarm = models.IntegerField(default=0,verbose_name="Humedad Alarma inferior") 
#     cpd = models.ForeignKey(Cpd, null=True,blank=True, on_delete=models.SET_NULL,verbose_name="CPD asociado")
#     def __str__(self):
#         return self.name
#     class Meta:
#         verbose_name="Alarma"
#         verbose_name_plural="Alarmas"


# class Alarm_Action(models.Model):    
#     created_at =models.DateTimeField(auto_now_add=True,verbose_name="Creación")
#     data = models.CharField(max_length=200,verbose_name="datos de la alarma")
#     alarm = models.ForeignKey(Alarm, on_delete=models.CASCADE,verbose_name="Alarma")