from django.shortcuts import render , redirect
from django.views.generic import ListView, DetailView
from iot_django.models.device import *
from cpds_monitor.models import *
from django.urls import reverse, reverse_lazy
from django.utils.decorators import method_decorator
from django.contrib.admin.views.decorators import staff_member_required
from django.contrib.auth.decorators import permission_required,login_required
from django.views.generic.list import ListView 
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView , UpdateView, DeleteView
from iot_django.forms import DeviceForm, DeviceCreateForm
from django.contrib.auth.models import User
from django.http import JsonResponse
from datetime import datetime, timedelta


class CpdListView ( ListView):
    model = Cpd 
    template_name = 'cpds.html'
    permission_required = ('cpds_monitor.access_cpds_aplications')

    def get_queryset(self):
        user=self.request.user
        cpds = Cpd.objects.filter(device_id__device_user_id__groups__in = user.groups.all()).distinct()
        return cpds
     



@login_required
def getDataTemHum(request):
    
    days = int(request.GET.get('days', None))
    user_app = User.objects.filter(username=request.GET.get('user', None)).first()
    cpds = Cpd.objects.filter(device_id__device_user_id__groups__in = user_app.groups.all()).distinct()
    lists= {
    }
    
    for cpd in cpds:
        device = cpd.device
        actions = []
        actions.append(device.action_set.filter(aplication_id=1))
        for action in actions:
            #values=action[0].action_values_set.all().filter(action_values_discriminate__contains=filter)[:number]
            values_hum=action[0].action_values_set.all().filter(action_values_discriminate__contains="_hum").filter(action_values_created_at__gte=datetime.now() - timedelta(days=(days)))
            values_temp=action[0].action_values_set.all().filter(action_values_discriminate__contains="_temp").filter(action_values_created_at__gte=datetime.now() - timedelta(days=(days)))            
            values_set_hum = []
            values_set_temp = []            
            for value in values_hum:
                timestamp=value.action_values_created_at.timestamp() * 1000
                values_set_hum.append([timestamp,float(value.action_values_values)])
            for value in values_temp:
                timestamp=value.action_values_created_at.timestamp() * 1000
                values_set_temp.append([timestamp,float(value.action_values_values)])
            lists[cpd.name]={"hum": values_set_hum,"temp": values_set_temp}
    return JsonResponse(lists)