from django.contrib import admin
from iot_django.models.device import *
from iot_django.models.aplication import *





#DEVICE
 
class Action_InLine(admin.TabularInline):
    model = Action
    extra = 0

class Device_admin(admin.ModelAdmin):
    inlines = [Action_InLine]
    readonly_fields=('device_created_at','device_updated_at')
    list_display=('device_alias','device_name', 'device_user','device_updated_at')
    search_fields=('device_alias','device_MQTT_ID', 'device_description','device_user__username')
    date_hierarchy='device_updated_at'
    
    #permisos por grupo
    def get_readonly_fields(self, request, obj=None):
        if request.user.groups.filter(name="Cliente IOT").exists():
            return ('device_created_at','device_updated_at','device_MQTT_ID')
        else:
            return ('device_created_at','device_updated_at')
    def save_model(self, request, obj, form, change):
        obj.device_user = request.user
        super().save_model(request, obj, form, change)
            
    #pass

class Action_type_admin(admin.ModelAdmin):
    pass

class Aplication_admin(admin.ModelAdmin):
    pass

admin.site.register(Device,Device_admin)
admin.site.register(Action_type,Action_type_admin)
admin.site.register(Application,Aplication_admin)