from django import forms
from iot_django.models.device import *


class ContactForm(forms.Form):
    name= forms.CharField(label="Nombre", required=True, widget=forms.TextInput(
        attrs={'class':'form-control','placeholder':'Escribe tu nombre'}
    ), min_length=3,max_length=100)
    email=forms.EmailField(label="Email", required=True, widget=forms.EmailInput(
        attrs={'class':'form-control','placeholder':'Escribe tu email'}
    ), min_length=3,max_length=100)
    content=forms.CharField(label="Contenido", required=True , widget=forms.Textarea(
        attrs={'class':'form-control','rows':'rows-3','placeholder':'Escribe tu mensaje'}
    ), min_length=10,max_length=1000)





############################################################
#####################      Devices       ###################
############################################################


class DeviceForm(forms.ModelForm):
    class Meta:
        model = Device
        fields = '__all__'
        exclude = ('device_user',)
        widgets ={
            'device_name':forms.TextInput(
            attrs={'class':'form-control','placeholder':'Selecciona un nombre de dispositivo'}
            )
        }
    
    # def clean_device_name(self):
    #     device_name = self.cleaned_data.get("device_name")        
    #     if Device.objects.filter(device_name=device_name).exists():
    #         raise forms.ValidationError("El nombre ya está registrado, prueba con otro.")
    #     return device_name

    # def clean_device_MQTT_ID(self):
    #     device_MQTT_ID = self.cleaned_data.get("device_MQTT_ID")        
    #     if Device.objects.filter(device_MQTT_ID=device_MQTT_ID).exists():
    #         raise forms.ValidationError("El MQTT ID ya esta registrado, prueba con otro")
    #     return device_MQTT_ID

    

class DeviceCreateForm(forms.ModelForm):    
    #device_name = forms.CharField(required=True, help_text="Requerido. 150 carácteres como máximo y debe ser válido.")
    class Meta:
        model = Device
        fields = '__all__'
        exclude = ('device_user',)
        widgets ={
            'device_name':forms.TextInput(
            attrs={'class':'form-control','placeholder':'Selecciona un nombre de dispositivo',}
            ),
            'device_alias':forms.TextInput(
            attrs={'class':'form-control','placeholder':'Escribe un alias',}
            ),
            'device_location_latitude':forms.TextInput(
            attrs={'class':'form-control','placeholder':'Longitud',}
            ),
            'device_location_longitude':forms.TextInput(
            attrs={'class':'form-control','placeholder':'Latitud',}
            ),
            'device_MQTT_ID':forms.TextInput(
            attrs={'class':'form-control','placeholder':'ID configurado en el dispositivo (único)',}
            ),
            'device_description':forms.Textarea(
            attrs={'class':'form-control','placeholder':'Escribe una descripción',}
            ),
            'device_is_active':forms.NumberInput(
            attrs={'class':'form-control','placeholder':'¿Esta activo este elemento? 1 Si, 0 No',}
            ),
            
        }
    

    def clean_device_name(self):
        device_name = self.cleaned_data.get("device_name")        
        if Device.objects.filter(device_name=device_name).exists():
            raise forms.ValidationError("El nombre ya está registrado, prueba con otro.")
        return device_name

    def clean_device_MQTT_ID(self):
        device_MQTT_ID = self.cleaned_data.get("device_MQTT_ID")        
        if Device.objects.filter(device_MQTT_ID=device_MQTT_ID).exists():
            raise forms.ValidationError("El MQTT ID ya esta registrado, prueba con otro")
        return device_MQTT_ID



############################################################
#####################      Actions       ###################
############################################################

class ActionCreateForm(forms.ModelForm):    
    #Action_name = forms.CharField(required=True, help_text="Requerido. 150 carácteres como máximo y debe ser válido.")
    #device_device = 
    class Meta:
        model = Action
        fields = '__all__'
        exclude = ('device_device',)
        widgets ={
            'action_name':forms.TextInput(
            attrs={'class':'form-control','placeholder':'Escribe un nombre'}
            )
        }

    
class ActionForm(forms.ModelForm):
    pass  
    class Meta:
        model = Action
        fields = '__all__'

        



# class DeviceForm(forms.ModelForm):
#     class Meta:
#         model = Device
#         fields = '__all__'
#         widgets ={
#             'device_name':forms.TextInput(
#             attrs={'class':'form-control','placeholder':'Selecciona un nombre de dispositivo'}
#             )
#         }
#     def clean_device_name(self):
#         device_name = self.cleaned_data.get("device_name")        
#         if Device.objects.filter(device_name=device_name).exists():
#             raise forms.ValidationError("El nombre ya está registrado, prueba con otro.")
#         return device_name

#     def clean_device_MQTT_ID(self):
#         device_MQTT_ID = self.cleaned_data.get("device_MQTT_ID")        
#         if Device.objects.filter(device_MQTT_ID=device_MQTT_ID).exists():
#             raise forms.ValidationError("El MQTT ID ya esta registrado, prueba con otro")
#         return device_MQTT_ID