# Generated by Django 3.1.7 on 2021-03-18 09:08

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('iot_django', '0008_auto_20210317_0848'),
    ]

    operations = [
        migrations.CreateModel(
            name='Action',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('pin_name', models.CharField(max_length=200)),
                ('pin_actual_value', models.CharField(max_length=200)),
                ('pin_description', models.CharField(max_length=500)),
                ('pin_created_at', models.DateTimeField(auto_now_add=True)),
                ('pin_updated_at', models.DateTimeField(auto_now_add=True)),
                ('pin_number', models.IntegerField(default=1)),
                ('pin_type', models.CharField(choices=[('action/onoff', 'Salida'), ('action/readinput', 'Entrada'), ('action/readtemp', 'Sensor de Temperatura')], default='action/onoff', max_length=50)),
            ],
        ),
        migrations.RemoveField(
            model_name='pin_8266_topic',
            name='pin_8266',
        ),
        migrations.CreateModel(
            name='Device',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('device_name', models.CharField(max_length=200)),
                ('device_alias', models.CharField(max_length=200)),
                ('device_location_latitude', models.CharField(default=None, max_length=70)),
                ('device_location_longitude', models.CharField(default=None, max_length=70)),
                ('device_MQTT_ID', models.CharField(max_length=100)),
                ('device_description', models.CharField(max_length=500)),
                ('device_is_active', models.IntegerField(default=0)),
                ('device_created_at', models.DateTimeField(auto_now_add=True)),
                ('device_updated_at', models.DateTimeField(auto_now_add=True)),
                ('slug', models.SlugField(default='a', max_length=40, unique=True)),
                ('device_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Action_values',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('action_values_device_id', models.CharField(max_length=250)),
                ('action_values_values', models.CharField(max_length=250)),
                ('action_values_created_at', models.DateTimeField(auto_now_add=True)),
                ('action_values_action', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='iot_django.action')),
            ],
        ),
        migrations.AddField(
            model_name='action',
            name='device_device',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='iot_django.device'),
        ),
    ]
