from django.db import models
from django.contrib.auth.models import User
from django.contrib.auth.models import Group
import paho.mqtt.publish as publish
from django.dispatch import receiver
from django.db.models.signals import post_save



class Application(models.Model):
    name = models.CharField(max_length=100,verbose_name="Nombre de la aplicacion")
    description = models.CharField(max_length=500,verbose_name="Descripcion")
    created_at =models.DateTimeField(auto_now_add=True,verbose_name="Creación")
    updated_at =models.DateTimeField(auto_now=True,verbose_name="Actualización")
    users = models.ManyToManyField(User, verbose_name="Usuarios")
    groups  = models.ManyToManyField(Group, verbose_name="Grupos")
    
    class Meta:
        verbose_name="aplicacion"
        verbose_name_plural="aplicaciones"
        ordering= ["-updated_at"]
    def __str__(self):
        return self.description
