from django import template
from iot_django.models import *
from iot_django.models import device
from cpds_monitor.models import Cpd
from datetime import datetime, timedelta
from django.contrib.auth.models import Group, User

register = template.Library()

@register.simple_tag
def has_device_grop(user, user_device):
    #user_device = Device.objects.get(device.device_user)
    groups_user = user.groups.all()
    groups_user_device = user_device.groups.all()
    for group in groups_user:
        if group in groups_user_device:
            return True
    return False

@register.simple_tag
def get_devices_group_user(user):
    user_device = device.Device.objects.filter(device_user_id__groups__in=user.groups.all()).distinct()
    return user_device
    


@register.simple_tag
def has_panel_grop(user, user_panel):
    #user_device = Device.objects.get(device.device_user)
    groups_user = user.groups.all()
    groups_user_panel = user_panel.groups.all()
    for group in groups_user:
        if group in groups_user_panel:
            return True
    return False


@register.simple_tag
def last_values_action(action, number):
    return action.action_values_set.all()[:number]

@register.simple_tag
def get_intensity_series_values_char(action, position,days_last=1):
    values=[]
    for value in action.action_values_set.all().filter(action_values_created_at__gte=datetime.now() - timedelta(days=(days_last))):
        try:
            values.append([value.action_values_created_at.timestamp() * 1000, float(value.action_values_values.split(',')[position])])
        except:
            pass
    return values

@register.simple_tag
def get_temp_values_char(action,days_last=1):
    values = []
    for value in action.action_values_set.all().filter(action_values_discriminate__contains='_temp').filter(action_values_created_at__gte=datetime.now() - timedelta(days=(days_last))):
        values.append([value.action_values_created_at.timestamp() * 1000,float(value.action_values_values)])
    return values

@register.simple_tag
def get_hum_values_char(action, days_last=1):
    values = []
    for value in action.action_values_set.all().filter(action_values_discriminate__contains='_hum').filter(action_values_created_at__gte=datetime.now() - timedelta(days=(days_last))):
        values.append([value.action_values_created_at.timestamp() * 1000,float(value.action_values_values)])
    return values

# @register.simple_tag
# def get_all_cpds_temperature_by_group(user, number, filter):
#     actions = list(device.Action.objects.all().filter(aplication_id=1))    
#     devices = []    
#     lists={}  
#     for action in actions:
#         values=action.action_values_set.all().filter(action_values_discriminate__contains=filter)[:number]
#         values_set = []
#         for value in values:
#             values_set.append([value.action_values_created_at.timestamp() * 1000,float(value.action_values_values)])
#         lists[action]=values_set
#     return lists;

@register.simple_tag
def get_all_cpds_temperature_by_group(user, filter, days_last=1):
    #actions = list(device.Action.objects.all().filter(aplication_id=1))
    #devices = Cpd.objects.all()
    cpds = list(Cpd.objects.filter(device_id__device_user_id__groups__in = user.groups.all()).distinct())
    lists={}
    for cpd in cpds:
        device = cpd.device
        actions = []
        actions.append(device.action_set.filter(aplication_id=1))
        for action in actions:
            #values=action[0].action_values_set.all().filter(action_values_discriminate__contains=filter)[:number]
            values=action[0].action_values_set.all().filter(action_values_discriminate__contains=filter).filter(action_values_created_at__gte=datetime.now() - timedelta(days=(days_last)))
            values_set = []
            for value in values:
                values_set.append([value.action_values_created_at.timestamp() * 1000,float(value.action_values_values)])
            lists[cpd.name]=values_set
    return lists;


@register.simple_tag
def last_temperature(action):
    return action.action_values_set.all().filter(action_values_discriminate__contains='_temp').reverse().last().action_values_values

@register.simple_tag
def last_humidity(action):
    return action.action_values_set.all().filter(action_values_discriminate__contains='_hum').reverse().last().action_values_values



    