"""iot_django URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.contrib.auth import views as auth_views
from django.contrib import admin
from django.urls import path
from django.conf.urls import url
from django.conf.urls import include
from django.urls import path
from django.conf import settings
from django.views.generic import TemplateView
from iot_django.views import home_views,user_views,device_views,action_views



from django.contrib.auth.decorators import login_required, permission_required


urlpatterns = [    
    url('registro/', user_views.registro, name='registro'),
    url('contactos/', home_views.contactos, name='contactos'),
    #url('devices/', device_views.allDevices, name='devices'),
    #path('device/<slug:slug>/', device_views.Device_detail, name='device'),
    #url(r'^$', home_views.home,name='home'),
    path('', home_views.HomePageView.as_view(), name='home'),
    path('admin/', admin.site.urls),

    #panels views
    path('panels/', login_required(user_views.panels), name='panels'),

    #objects Views
    path('devices/', login_required(device_views.DeviceListView.as_view()), name='devices'),
    path('device/<int:pk>/', device_views.DeviceDetailView.as_view(), name='device'),
    path('device/create', device_views.DeviceCreate.as_view(), name='deviceCreate'),
    path('device/update/<int:pk>/', device_views.DeviceUpdate.as_view(), name='deviceUpdate'),
    path('device/delete/<int:pk>/', device_views.DeviceDelete.as_view(), name='deviceDelete'),
    #actions
    path('action/<int:pk>/', login_required(action_views.ActionDetailView.as_view()), name='action'),
    path('action/create/<int:device_id>/', action_views.ActionCreate.as_view(), name='actionCreate'),
    path('action/update/<int:pk>/', action_views.ActionUpdate.as_view(), name='actionUpdate'),
    path('action/delete/<int:pk>/', action_views.ActionDelete.as_view(), name='actionDelete'),

    #Ajax
    path('ajax/get_electricity/', login_required(action_views.getDataElectricity), name='AjaxGetElectricity'),
    path('ajax/get_temphum/', login_required(action_views.getDataTemHum), name='AjaxGetTempHum'),



    #path('profile/', user_views.ProfileUpdate.as_view(), name="profile"),

    #app cpds_monitor
    path('cpds_monitor/', include('cpds_monitor.urls')),

    #app enery_monitor
    path('energy_monitor/', include('energy_monitor.urls')),

]


admin.site.site_header = 'Sistema IoT IBERTEC - TFG UOC'
admin.site.site_title = 'Portal de Administracion IBERTEC'
admin.site.index_title = "Bienvenidos al portal de administración de IoT - TFG UOC"

urlpatterns += [
    path('accounts/', include('django.contrib.auth.urls')),
]

if settings.DEBUG:
    from django.conf.urls.static import static
    urlpatterns+= static(settings.MEDIA_URL , document_root=settings.MEDIA_ROOT)