from django.shortcuts import render, redirect
from django.urls import reverse
from iot_django.forms import ContactForm
from django.core.mail import EmailMessage
#template view
from django.views.generic import TemplateView
from django.views.generic.edit import FormView


def home(request):
    context = {}
    return render(request, "home.html",context)

class HomePageView(TemplateView):
    template_name= "home.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context={'titulo':"T HOME"}
        return context
    
    def get(self, request, *args, **kwargs):
        return render(request, self.template_name, self.get_context_data())



class ContactView(FormView):
    template_name = 'contactosObjectForm.html'
    form_class = ContactForm
    success_url = '/thanks/'

    def form_valid(self, form):
        # This method is called when valid form data has been POSTed.
        # It should return an HttpResponse.
        form.send_email()
        return super().form_valid(form)

def contactos(request):
    contact_form=ContactForm()    
    if request.method == "POST":
        contact_form = ContactForm(data=request.POST)
        if contact_form.is_valid:
            name= request.POST.get('name', '')
            email= request.POST.get('email', '')
            content= request.POST.get('content', '')
            #eNVIAMOS EL CORREO Y REDIRECCIONAMOS
            email= EmailMessage(
                "IOT  Muevo mensaje de contacto",
                "De {} <{}>\n\nEscribió: \n\n{}".format(name,email,content),
                "no-contestar@inbox.mailtrap.io",
                ["juaniberobi@gmail.com"],
                reply_to=[email]
            )
            try:
                email.send()
                return redirect(reverse('contactos')+"?ok")
            except:
                #envío fallido
                return redirect(reverse('contactos'), "?fail")
    context = {'form':contact_form}
    return render(request, "contactos.html",context)